// JavaScript Document
/*----------------------------------------------------------------
	* create: 2007/04/01	
	* system name: FlyView On Web
	* program name: FlyViewer
	* file name:flvw.js
	* author: WATANABE Takeshi(FUKUNEKO Corporation)
	* comment: 自動アップローダと連携し、Webブラウザ上で任意のコンテンツを自動切換え表示するシステム
	*			静止画、Flash、テロップを扱うことができる
	* version: 1.3.1.2
	* update: 2008/6/4
	*	update information:
	*	comment: setFlvwManagerIntervalメソッド、setGettingDataIntervalメソッドを追加
	* version: 1.3.1.1
	* update: 2008/6/3
	*	update information:
	*	comment: チェックボックスが正常に動作しない不具合を修正した
	* version: 1.3.1.0
	* update: 2008/4/15
	*	update information:
	*	comment: setDataDirectoryメソッドを追加。
	* version: 1.3.0.1
	* update: 2008/04/07
	*	update infomation:
	* 	comment: FlvList.xmlのグループの順序がIDと異なる場合に、メニューのチェックが正常に動作しない問題を修正した
	* version: 1.3.0
	* update: 2007/12/12
	*	update infomation:
	* 	comment: Fixedグループの各コンテンツで任意の時間で切替が可能になった
	* 	comment: Fixedグループの切替に同期するラベルの指定が可能になった
	* version: 1.2.0
	* update: 2007/06/15
	*	update infomation:
	* 	comment: FixedグループでFlashを扱えるようになった
	* version: 1.1.0
	* update: 2007/06/14
	*	update infomation:
	* 	comment: GroupMapping クラスにsetUserDefElement()メソッドを追加
	* Copyright(c): 2007年 福猫株式会社
	* このプログラムの全てあるいは一部を無断でコピー、転売、販売、使用することを禁じます。
*/


// ネームスペースの作成
if( typeof com == "undefined" ) var com = {};
if( typeof com.fukuneko == "undefined" ) com.fukuneko = {};

/**
 * Flvwオブジェクトの作成
 */
com.fukuneko.Flvw = {
// クラス変数
// 非同期通信用のオブジェクト
	httpObj : null,

// データ取得処理中にtrueになる
	isProcessing : false,

	telop : null,
	infoElement : null,
	groups : null, // 実行中のグループ情報オブジェクト
	groupsNew : null, // 新規の情報を格納するグループオブジェクト（テンポラリ）
	groupsTemp : null, // テンポラリ用グループオブジェクト
	timerID : null, // タイマーのID
	groupsNewUpdate : "0000-00-00 00:00:00", // 取得済のグループ情報の更新日時
	isUpdate : false, // アップデートをするかどうか
	isGroupsLock : false, // グループオブジェクトの更新中かどうか
	flvwManagerInterval : 10, // FlvwManagerを呼び出す間隔(Tick)
	gettingDataInterval : 5000, // 更新データを取りに行く間隔(Tick)
	gotDataLastTime : 0, // 更新データ取得処理を最後に行った時間（ミリ秒）
	dataDirectory : "data/", // 画像データを格納するディレクトリ（使用するhtmlからの相対パスまたは絶対パス）
	flvListDirectory : "", // FlvListファイルを格納するディレクトリ（使用するhtmlからの相対パスまたは絶対パス）
	flvListFile : "FlvList.xml", // FlvListファイル名
	gmap : null // GroupMappingクラスを定義後、インスタンスを生成する
};
com.fukuneko.Flvw.flvListDirectory = com.fukuneko.Flvw.dataDirectory; // デフォルトはデータディレクトリ

	
/**
*	データディレクトリをセットする
*	@access public
*	@param	string	dataDirectory データディレクトリ
**/
com.fukuneko.Flvw.setDataDirectory = function(dataDirectory)
{
	com.fukuneko.Flvw.flvListDirectory = dataDirectory;
	com.fukuneko.Flvw.dataDirectory = dataDirectory;
}

/**
*	FlvwManagerを呼び出す間隔をセットする(Tick単位)
*	@access public
*	@param	int	interval 間隔(Tick)
**/
com.fukuneko.Flvw.setFlvwManagerInterval = function(interval)
{
	com.fukuneko.Flvw.flvwManagerInterval = interval;
}

/**
*	更新データを取りに行く間隔をセットする(Tick単位)
*	@access public
*	@param	int	interval 間隔(Tick)
**/
com.fukuneko.Flvw.setGettingDataInterval = function(interval)
{
	com.fukuneko.Flvw.gettingDataInterval = interval;
}

// グループマッピングクラス --　ここから
// グループIDとDOMのエレメントIDをマッピングした情報を保持する
/** コンストラクタ
 *	@access	public
　*/
com.fukuneko.Flvw.GroupMapping = function()
{
	this.map = new Array();
	this.userElements = new Array();
	this.userElementsAttr = new Array();
};

com.fukuneko.Flvw.GroupMapping.prototype = {
	/**
	 *	マッピング情報をセットする
	 *	@access public
	 *	@param	int		groupId			グループID
	 *	@param	string	areaElemnetId	グループが表示される領域のDOMのID
	 *	@param	string	innerElementId	グループのコンテンツを格納する要素DOMのID
	 *	@param	string	menuGroupElementId このグループの選択メニューが表示される領域DOMのID
	 *	@param	string	labelElementId	グループのラベルを表示する領域のDOMのID
	 **/
	add : function(  groupId, areaElementId, innerElementId, menuGroupElementId, labelElementId )
	{
		this.map[groupId] = new Array();
		this.map[groupId]["AreaElementId"] = areaElementId;
		this.map[groupId]["InnerElementId"] = innerElementId;
		
		// オーバーロードを擬似的に行なう
		switch(arguments.length)
		{
			case 4:
				this.map[groupId]["MenuGroupElementId"] = menuGroupElementId;
				break;
			
			case 5:
				this.map[groupId]["MenuGroupElementId"] = menuGroupElementId;
				this.map[groupId]["LabelElementId"] = labelElementId;
				break;
					
			default:
				this.map[groupId]["MenuGroupElementId"] = null;
				this.map[groupId]["LabelElementId"] = null;
				break;	
		}
		
	},
	/**
	 *	グループIDに対応する表示領域のDOMのIDを取得する
	 *	@access public
	 *	@param	{string}		groupId			グループID
	 *	@return	{string}	グループが表示される領域のDOMのID ない場合はnull
	 */
	getAreaElementId : function( groupId )
	{
		try
		{
			var id = this.map[groupId]["AreaElementId"];
			return id;
		}
		catch(ex)
		{
			return null;
		}
	},
	/**
	 *	グループのコンテンツを格納する要素DOMのIDを取得する
	 *	@access public
	 *	@param	{string}		groupId			グループID
	 *	@return	{string}	グループのコンテンツを格納する要素DOMのID ない場合はnull
	 **/
	getInnerElementId : function( groupId )
	{
		try
		{
			var id = this.map[groupId]["InnerElementId"];
			return id;
		}
		catch(ex)
		{
			return null;
		}
	},
	/**
	 *	グループの選択メニューを格納する要素DOMのIDを取得する
	 *	@access public
	 *	@param	{string}		groupId			グループID
	 *	@return	{string}	グループのコンテンツを格納する要素DOMのID ない場合はnull
	 **/
	getMenuGroupElementId : function( groupId )
	{
		try
		{
			var id = this.map[groupId]["MenuGroupElementId"];
			return id;
		}
		catch(ex)
		{
			return null;
		}
	},
	
	/**
	 *	ラベルを表示する要素DOMのIDを取得する
	 *	@access public
	 *	@param	{string}		groupId			グループID
	 *	@return	{string}	ラベルを表示する要素DOMのID ない場合はnull
	 **/
	getLabelElementId : function( groupId )
	{
		try
		{
			var id = this.map[groupId]["LabelElementId"];
			return id;
		}
		catch(ex)
		{
			return null;
		}
	},
	
	/**
	 *	ユーザーがHTML中に定義したエレメントを取得し、セットする。
	 *	HTMLのロードが完了後呼び出す必要がある
	 *	@access public
	 *	@return	{bool} true:成功 || false:失敗
	 **/
	setUserDefInnerElements : function()
	{ 
		var mapCount = this.map.length;
		if( this.map.length < 1 ) return false;
		
		for( var key in this.map )
		{
			try
			{
				this.userElements[key] = document.getElementById(this.map[key]["InnerElementId"]);
				this.userElementsAttr[key] = new Array();
				this.userElementsAttr[key]["width"] = this.userElements[key].getAttribute("width");
				this.userElementsAttr[key]["height"] = this.userElements[key].getAttribute("height");
			}
			catch(ex)
			{
				this.userElements[key] = null;
			}
		}
		
		return true;
	},
	
	/**
	 *	ユーザーがHTML中に定義したエレメントを取得する。
	 *	@access public
	 *	@param	{string} groupId グループID
	 *	@return	{object} 成功のときは、エレメント || 失敗のときはnull
	 **/
	getUserDefInnerElement : function(groupId)
	{
		return this.userElements[groupId];
	},
	
	/**
	 *	ユーザーがHTML中に定義したエレメントの属性値(幅と高さ）を初期値にリストアする（IE対策用）
	 *	IEはFlashを表示後、幅と高さの属性値が画像サイズへ変更されてしまう。
	 *	@access public
	 *	@param	{string} groupId グループID
	 **/
	restoreUserDefInnerElementAttr : function(groupId)
	{
		this.userElements[groupId].setAttribute("width", this.userElementsAttr[groupId]["width"]);
		this.userElements[groupId].setAttribute("height", this.userElementsAttr[groupId]["height"]);
	}
};

com.fukuneko.Flvw.gmap = new com.fukuneko.Flvw.GroupMapping(); // マッピング情報（htmlヘッダ中のJavaScriptで値をセットする
/****
例）
with(com.fukuneko.Flvw){
	gmap.add(0, "ImageArea0", "ImageElement0", "MenuGroup0");
	gmap.add(1, "ImageArea1", "ImageElement1", "MenuGroup1");
	gmap.add(2, "TelopArea0", "TelopText0", "MenuGroup2");
	gmap.add(3, "TelopArea1", "TelopText1", "MenuGroup3");
}
*****/


// グループマッピングクラス -- ここまで


// テロップクラス定義 -- ここから
//
/** コンストラクタ
 *	@access	public
 * 	@param	{int}		Id テロップオブジェクトのID
 *	@param	{string}	areaId	テロップが実際に表示される領域のDOMのID
 *	@param	{string}	groupId	テロップの文字列を表示するグループのID
 *	@param	{int}	step	テロップを一度に動かすピクセル値
 */
com.fukuneko.Flvw.Telop = function( Id, areaId, groupId, step )
{
	this.Id = Id;
	this.areaElement = document.getElementById( areaId );//テロップが実際に表示される領域（divタグ）
	this.textElement = com.fukuneko.Flvw.gmap.getUserDefInnerElement( groupId );//テロップの文字列を格納する要素（spanタグ）
	
	this.areaElement.style.overflow = "hidden";
	this.textElement.style.position = "relative"; //親エレメントからの相対位置とする
	this.textElement.style.whiteSpace = "nowrap"; //折り返しを禁止する
	
	this.areaWidth = this.areaElement.offsetWidth;
	this.areaHeight = this.areaElement.offsetHeight;
	this.textWidth = this.textElement.offsetWidth;
	this.textHeight = this.textElement.offsetHeight;
	
	this.step = step;
}
com.fukuneko.Flvw.Telop.prototype = {
	type : 'Telop Object',
	interval : 60, // テロップを動かすインターバル（Tick）
	prevTick : 0,
	offset : -1,
	name : "",
	isRequireInit : true,
	selected : true,
	link : null,
	target : null,
	linkElement : null,
	interval : null,
	
	/**
	 *	テロップの文字列をセットする
	 *	@access public
	 *	@param	string text	セットする文字列
	 **/
	setText : function( text )
	{ 
		this.text = text;
	},
	
	/**
	 *	テロップをスタート位置にセットする
	 *	@access public
	 */
	setToStartPosition : function()
	{
		this.positionX = this.areaWidth;
		this.textElement.style.left = this.positionX+"px";
		this.textElement.innerHTML = this.text;
		this.textWidth = this.textElement.offsetWidth;
		this.textHeight = this.textElement.offsetHeight;
		if( this.textHeight < this.areaHeight )
		{
			this.positionY = (this.areaHeight - this.textHeight) / 2 + this.offset;	
		}
		else
		{
			this.positionY = this.offset;
		}
		this.textElement.style.top = this.positionY+"px";
		this.isRequireInit = false;
		
		if( this.linkElement != null )
		{
			if( this.textElement.firstChild != undefined )
			{
				this.textElement.removeChild(this.textElement.childNodes[0]);
				this.textElement.value = "";	
			}
			
			this.linkElement.innerHTML = this.text;
			
			this.textElement.appendChild(this.linkElement);
			
			if( this.areaElement.firstChild != undefined )
			{
				this.areaElement.removeChild(this.areaElement.childNodes[0]);
			}
			this.areaElement.appendChild(this.textElement);
		}
		else
		{
			if( this.areaElement.firstChild != undefined )
			{
				this.areaElement.removeChild(this.areaElement.childNodes[0]);
			}
			this.areaElement.appendChild(this.textElement);
		}
	},
	
	/**
	 *	テロップを動かす
	 *	@return	{bool}	true:テロップが表示範囲にあるとき || false:テロップが表示範囲外になったとき
	 */
	move : function()
	{
		var curTick = (new Date()).getTime();
		//alert( curTick );
		if( curTick > this.prevTick + this.interval )
		{
			this.prevTick = curTick;
			
			this.positionX -= this.step;
			this.textElement.style.left = this.positionX+"px";
			if( this.positionX >= (this.textWidth * -1) )
			{
				return true;
			}
			else
			{
				this.isRequireInit = true;
				return false;
			}
		}
		else
		{
			return true;
		}
	},
	
	/**
	 * リンクをセットする
	 * @param {String} link リンク
	 * @param {String} target 表示するウィンドウターゲット
	 */
	setLink : function(link, target)
	{
		this.link = link;
		this.target = target;
		
		if( this.link == null ) return;
		
		this.linkElement = document.createElement("a");
		this.linkElement.href = this.link;

		if( this.target != null )
		{
			this.linkElement.target = this.target;			
		}
	},
	
	/**
	 *	デストラクタ（オブジェクト内の変数、オブジェクトを破棄する）
	 */
	dispose : function()
	{
		delete this.Id;
		delete this.areaWidth;
		delete this.areaHeight;
		delete this.textWidth;
		delete this.textHeight;
		delete this.step;
		delete this.type;
		delete this.interval;
		delete this.prevTick;
		delete this.offset;
		delete this.name;
		delete this.isRequireInit;
		delete this.selected;
	}
};
// テロップクラス定義 -- ここまで

// 静止画クラス定義 -- ここから
/// 
/** コンストラクタ
 *	@access	public
 *	@param	{int}		オブジェクトID	
 *	@param	{string}	areaId	静止画が実際に表示される領域のDOMのID
 *	@param	{string}	groupId	静止画を表示するグループのID
 */
com.fukuneko.Flvw.FlvImage = function( Id, areaId, groupId )
{
	this.Id = Id;
	this.areaElement = document.getElementById( areaId );//静止画が実際に表示される領域（divタグ）
	this.imageElement = com.fukuneko.Flvw.gmap.getUserDefInnerElement( groupId );//静止画を格納する要素（imgタグ）
	var labelElementId = com.fukuneko.Flvw.gmap.getLabelElementId(groupId);
	this.labelElement = null;
	if( labelElementId != null )
	{
		try{
			this.labelElement = document.getElementById( labelElementId );
		}
		catch(ex){
			this.labelElement = null;
		}	
	}
	
	this.areaElement.style.overflow = "hidden";
	
	this.image = new Image();
}
com.fukuneko.Flvw.FlvImage.prototype = {
	type : 'FlvImage Object',
	name : "",
	selected : true,
	alt : null,
	link : null,
	target : null,
	linkElement : null,
	detectStopped : false, //静止画の場合、常にfalse
	interval : null,
	
	/**
	 *	ファイル名をセットする
	 *	@param {String} fileName ファイル名
	 */
	setFile : function( fileName )
	{
		if( com.fukuneko.Flvw.dataDirectory == null || com.fukuneko.Flvw.dataDirectory == "" )
		{
			this.file = fileName;
		}
		else
		{
			this.file = com.fukuneko.Flvw.dataDirectory + "/" + fileName;
		}
	},
	
	/**
	 *	イメージをロードする
	 */
	loadImage : function()
	{
		var tick = new Date().getTime();
		this.image.src = this.file + "?tick=" + tick;
	},
	
	/**
	 * イメージを表示する
	 */
	showImage : function()
	{
		this.imageElement.src = this.image.src;
		if( this.alt != null )
		{
			this.imageElement.alt = this.alt;
		}
		else
		{
			this.imageElement.alt = this.name;				
		}
		
		if( this.linkElement != null )
		{
			this.linkElement.appendChild(this.imageElement);
			if( this.areaElement.firstChild != undefined )
			{
				this.areaElement.removeChild(this.areaElement.childNodes[0]);
			}
			this.areaElement.appendChild(this.linkElement);
		}
		else
		{
			if( this.areaElement.firstChild != undefined )
			{
				this.areaElement.removeChild(this.areaElement.childNodes[0]);
			}
			this.areaElement.appendChild(this.imageElement);
		}
		
		if( this.labelElement != null )
		{
			this.labelElement.innerHTML = this.name;
		}
	},
	
	/**
	 * リンクをセットする
	 * @param {String} link リンク
	 * @param {String} target 表示するウィンドウターゲット
	 */
	setLink : function(link, target)
	{
		this.link = link;
		this.target = target;
		
		if( this.link == null ) return;
		
		this.linkElement = document.createElement("a");
		this.linkElement.href = this.link;

		if( this.target != null )
		{
			this.linkElement.target = this.target;			
		}
	},
	
	/**
	 *	デストラクタ（オブジェクト内の変数、オブジェクトを破棄する）
	 */
	dispose : function()
	{
		delete this.Id;
		delete this.image;
		delete this.alt;
		delete this.link;
		delete this.type;
		delete this.name;
		delete this.selected;
		delete this.linkElement;
	}
	
};
// 静止画クラス定義 -- ここまで

// Flashクラス定義 -- ここから
/// 
/** コンストラクタ
 *	@access	public
 *	@param	{int}		オブジェクトID	
 *	@param	{string}	areaId	Flashが実際に表示される領域のDOMのID
 *	@param	{string}	groupId	Flashが表示されるグループのID
 */
com.fukuneko.Flvw.FlvFlash = function( Id, areaId, groupId )
{
	this.Id = Id;
	this.flashId = com.fukuneko.Flvw.gmap.getInnerElementId( groupId );
	
	this.areaElement = document.getElementById( areaId );//Flashが実際に表示される領域（divタグ）
	
	this.width = com.fukuneko.Flvw.gmap.getUserDefInnerElement( groupId ).getAttribute("width");
	this.height = com.fukuneko.Flvw.gmap.getUserDefInnerElement( groupId ).getAttribute("height");
	
	this.areaElement.style.overflow = "hidden";
	
	var labelElementId = com.fukuneko.Flvw.gmap.getLabelElementId(groupId);
	this.labelElement = null;
	if( labelElementId != null )
	{
		try{
			this.labelElement = document.getElementById( labelElementId );
		}
		catch(ex){
			this.labelElement = null;
		}	
	}
}
com.fukuneko.Flvw.FlvFlash.prototype = {
	type : 'FlvFlash Object',
	name : "",
	originalFileName : "",
	selected : true,
	alt : null,
	target : null,
	flashElement : null,
	originalFileName : "",
	quality : "high", // high（高画質） | midium（中画質）| row（低画質）
	loop : "false",
	wmode : "opaque", // opaque（透過しない） | transparent（透過）
	bgcolor : "", // #RRGGBB形式
	scale : "", // showall（デフォルト） | noborder | exactfit | noscale
	FlashVars : "",
	salign : "", // l | r | t | b | tl | tr | bl | br 
	detectStopped : false,
	
	/**
	 *	ファイル名をセットする
	 *	@param {String} fileName ファイル名
	 */
	setFile : function( fileName )
	{
		this.originalFileName = fileName;
		var tick = new Date().getTime();
		fileName = fileName + "?tick=" + tick;
		if( com.fukuneko.Flvw.dataDirectory == null || com.fukuneko.Flvw.dataDirectory == "" )
		{
			this.file = fileName;
		}
		else
		{
			this.file = com.fukuneko.Flvw.dataDirectory + "/" + fileName;
		}
	},
	
	
	/**
	 * Flashを表示する
	 */
	showFlash : function()
	{
		if( this.flashElement != null ) delete this.flashElement;
		
		this.html = '<object id="' + this.flashId + '" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"';
		this.html += ' codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,19,0"';
		this.html += ' width="' + this.width + '" height="' + this.height + '" >';
		this.html += ' <param name="movie" value="' + this.file + '" />';
		this.html += ' <param name="quality" value="' + this.quality + '" />';
		this.html += ' <param name="loop" value="' + this.loop + '" />';
		this.html += ' <param name="wmode" value="' + this.wmode + '" />';
		this.html += ' <param name="bgcolor" value="' + this.bgcolor + '" />';
    	this.html += '<embed name="' + this.flashId + '" src="' + this.file + '" quality="' + this.quality + '"';
		this.html += ' loop="' + this.loop + '"';
		this.html += ' pluginspage="http://www.macromedia.com/go/getflashplayer"';
		this.html += ' type="application/x-shockwave-flash" width="' + this.width + '" height="' + this.height + '" ';
		this.html += ' wmode="'+ this.wmode +'" bgcolor="'+ this.bgcolor +'">';
		this.html += '</embed>';
		this.html += '</object>';
		
		this.areaElement.innerHTML = this.html;
		this.flashElement = document.getElementById(this.flashId);
		
		if( this.labelElement != null )
		{
			this.labelElement.innerHTML = this.name;
		}
	},
	
	/**
	 *	Flashを停止する
	 */
	stop : function()
	{
		try
		{
			this.flashElemnet.Stop();
		}
		catch(ex)
		{
			document[this.flashId].StopPlay();
		}
	},
	
	/**
	 *	Flashが再生中かどうか
	 *	@return {bool}	true:再生中 || false:再生中ではない（停止中など）
	 */
	isPlaying : function()
	{
		var state;
		try
		{
			state = this.flashElemnet.IsPlaying();
		}
		catch(ex)
		{
			state = document[this.flashId].IsPlaying();
		}
		
		return state;
	},
	
	
	/**
	 *	デストラクタ（オブジェクト内の変数、オブジェクトを破棄する）
	 */
	dispose : function()
	{
		delete this.Id;
		delete this.alt;
		delete this.link;
		delete this.type;
		delete this.name;
		delete this.selected;
		delete this.flashElement;
	}
	
};
// Flashクラス定義 -- ここまで





// グループクラス定義 -- ここから
/// 
/** コンストラクタ
 *	@access	public
 *	@param	{string}	groupId グループID
 *	@param 	{string}	groupType グループのタイプ（ Fixed または Telop　）
 *	@param	{string}	areaId	静止画が実際に表示される領域のDOMのID
 *	@param	{string}	innerId	静止画またはテロップを格納する要素DOMのID
 */
com.fukuneko.Flvw.Group = function( groupId, areaId, innerId, groupType )
{
	this.Id = groupId;
	this.areaId = areaId;
	this.innerId = innerId;
	this.groupType = groupType;
	this.objects = new Array();

	this.areaElement = document.getElementById( areaId );//静止画が実際に表示される領域（divタグ）
	//this.innerElement = document.getElementById( innerId );//静止画やテロップを格納する要素（imgタグ または spanタグ）
	
	if( this.areaElement == null )
	{
		this.enabled = false;
		return;
	}
	
	this.areaElement.style.overflow = "hidden";	
}

com.fukuneko.Flvw.Group.prototype = {
	type : 'Group Object',
	groupType : 'none',
	interval : 10,
	step : 3,
	currentIndex : -1,
	lastTime : 0, // FlvwManagerから呼び出された最新の時間
	lastUpdate : "0000-00-00 00:00:00", //グループコンテンツの更新時間
	enabled : true, // このグループが有効かどうか
	detectStopped : false, // グループの対象オブジェクトの終了を検知するかどうか（Flashのとき） 
	
	/**
	 * オブジェクトを追加する
	 * @param {Object} obj FlvImage,FlvFlash,Telopオブジェクト
	 */
	addObject : function( obj )
	{
		this.objects.push(obj);
	},
	
	/**
	 * 	オブジェクト配列の現在のインデックス値を次へ進める
	 */
	moveToNextObject : function()
	{
		if( this.objects == null ) 
		{
			this.currentIndex = -1;
			return;
		}
		
		if( this.objects.length < 1 )
		{
			if( this.objects[0].selected )
			{
				this.currentIndex = 0;
			}
			else
			{
				this.currentIndex = -1;
			}
			return;
		}
		
		var curIndex = this.currentIndex;
		var length = this.objects.length;
		
		var loopCount = 0;
		do
		{
			loopCount++;
			curIndex++;
			if( curIndex >= this.objects.length ) curIndex = 0;
			if( loopCount > length )
			{
				curIndex = -1;
				break;
			}
		}while( !this.objects[curIndex].selected );
		
		this.currentIndex = curIndex;
	},

	/**
	 * 	現在のインデックス値が指すオブジェクトを取得する
	 */
	getCurrentObject : function()
	{
		if( this.currentIndex == -1 ) return null;
		
		if( this.objects.length < 1 ) return null;
		
		return this.objects[this.currentIndex];
	},
	
	/**
	 * 	最後にアクセスした時間を更新する
	 * @param {Date} time 更新に使用する時間
	 */
	updateLastTime : function(time)
	{
		if( !this.detectStopped )
		{
			this.lastTime = time;
		}	
	},
	
	/**
	 *	デストラクタ（オブジェクト内の変数、オブジェクトを破棄する）
	 */
	dispose : function()
	{
		if( this.objects.length > 0 )
		{
			for( var i = 0; i < this.objects.length; i++ )
			{
				if( this.objects[i] != null ) this.objects[i].dispose();
				delete this.objects[i];
			}
		}
		
		delete this.Id;
		delete this.groupType;
		delete this.type;
		delete this.groupType;
		delete this.interval;
		delete this.step;
		delete this.currentIndex;
		delete this.lastTime;
		delete this.lastUpdate;
		delete this.enabled;		
	}
};
// グループクラス定義 -- ここまで


/**
 * 	日付時間の文字列フォーマットから日付時間オブジェクトを取得する
 *	@param	{string}	datetimestr	"YYYY-MM-DD hh-mm-ss"の形式
 *	@return	{Date}
 */
com.fukuneko.Flvw.GetDateTimeFromString = function( datetimestr )
{
	var str = datetimestr;
	var year = str.substr( 0, 4 );
	var month = str.substr( 5, 2 );
	var day = str.substr( 8, 2 );
	var hour = str.substr( 11, 2 );
	var minute = str.substr( 14, 2 );
	var second = str.substr( 17, 2 );
	
	return new Date( year, (month-1), day, hour, minute, second );
};


/**
 * 	グループIDから、対象のグループオブジェクトのインデックスを取得する
 *	@param	{Group[]}	groupsObj	グループオブジェクト配列
 *	@param	{string}	id			検索するグループID
 *	@return	{Date}
 **/
com.fukuneko.Flvw.GetGroupIndexById = function( groupsObj, id )
{
	if( groupsObj.length < 1 ) return -1;
	
	for( i = 0; i < groupsObj.length; i++ )
	{
		if( id == groupsObj[i].Id ) return i;	
	}
	
	return -1;
}


/**
 * サーバーからデータを取得する
 */
com.fukuneko.Flvw.GetData = function()
{
	if( com.fukuneko.Flvw.isProcessing ) return;
	
	com.fukuneko.Flvw.isProcessing = true;
	var tick = new Date().getTime();
	var URI = com.fukuneko.Flvw.flvListDirectory + "/" + com.fukuneko.Flvw.flvListFile + "?tick="+tick;
	try
	{
		com.fukuneko.Flvw.httpObj = com.fukuneko.Flvw.createXMLHttpRequest( com.fukuneko.Flvw.ProcessData );
		if( com.fukuneko.Flvw.httpObj )
		{
			com.fukuneko.Flvw.httpObj.open("GET", URI, true);
			com.fukuneko.Flvw.httpObj.send(null);
		}
	}
	catch(ex){}
	
};


/**
 * データ取得のステータスが変更になったときに呼ばれるコールバック関数
 */
com.fukuneko.Flvw.ProcessData = function()
{
	//var Flvw = com.fukuneko.Flvw;
	try
	{
		if ((com.fukuneko.Flvw.httpObj.readyState == 4) && (com.fukuneko.Flvw.httpObj.status == 200))
		{
			var xmlData = com.fukuneko.Flvw.httpObj.responseXML;
			
			var rootNode = xmlData.getElementsByTagName("FlyView");
			var version = rootNode[0].getAttributeNode("Version").value;
			// データリストのバージョンをチェック
			if( version != "1.0" )
			{
				com.fukuneko.Flvw.isProcessing = false;
				return;
			}
			
			// Updateノードデータの取得
			var updateNode = xmlData.getElementsByTagName("Update");
			var dtime = updateNode[0].firstChild.nodeValue;
			if( dtime == com.fukuneko.Flvw.groupsNewUpdate )
			{
				// 更新日時が同じなら処理を行わない
				com.fukuneko.Flvw.isProcessing = false;
				return;	
			}
			
			com.fukuneko.Flvw.groupsNewUpdate = dtime; // アップデート日付の更新
			
			//alert( "update:"+dtime );
			
			com.fukuneko.Flvw.isGroupsLock = true; // グループのロック
			
			com.fukuneko.Flvw.groupsTemp = new Array();
		
			// ContentノードとGroupノードデータの取得
			var contentNode = xmlData.getElementsByTagName("Content");
			var groupNodes = contentNode[0].getElementsByTagName("Group");
	
			for( var i = 0; i < groupNodes.length; i++ )
			{
				var groupId = groupNodes[i].getAttribute("Id");
				var groupType = groupNodes[i].getAttribute("Type");
				var interval = groupNodes[i].getAttribute("Interval");
				var step = groupNodes[i].getAttribute("Step");
				//alert( groupId + ", " + groupType +", " + interval + ", "+step );
				
				var areaId = com.fukuneko.Flvw.gmap.getAreaElementId(groupId);
				var innerId = com.fukuneko.Flvw.gmap.getInnerElementId(groupId);
				
				com.fukuneko.Flvw.groupsTemp[i] = new com.fukuneko.Flvw.Group( groupId, areaId, innerId, groupType );
				if( !com.fukuneko.Flvw.groupsTemp[i].enabled ) continue;
				
				var flashElement = com.fukuneko.Flvw.groupsTemp[i].flashElement;
				var paramElements = com.fukuneko.Flvw.groupsTemp[i].paramElements;
				var embedElement = com.fukuneko.Flvw.groupsTemp[i].embedElement;
				
				com.fukuneko.Flvw.groupsTemp[i].interval = parseInt(interval,10);
				com.fukuneko.Flvw.groupsTemp[i].step = parseInt(step,10);
				//com.fukuneko.Flvw.groupsTemp[i].groupType = groupType;
				com.fukuneko.Flvw.groupsTemp[i].lastUpdate = com.fukuneko.Flvw.groupsNewUpdate;
				
				
				// Groupノード内のObjectノードデータ取得
				var objectNodes = groupNodes[i].getElementsByTagName("Object");
				for( var j = 0; j < objectNodes.length; j++ )
				{
					var objectId = objectNodes[j].getAttribute("Id");
					var objectType = objectNodes[j].getAttribute("Type");
					var objectInterval = null;
					try{
						objectInterval = parseInt(objectNodes[j].getAttribute("Interval"), 10); //ver1.3以降	
						if( isNaN(objectInterval) ) objectInterval = null;
					}catch(ex){
						objectInterval = null;
					}
					//alert( groupId + ", " + objectId +", " + objectType );
					
					var objectName = objectNodes[j].getElementsByTagName("Name")[0].firstChild.nodeValue;
					var objectFile = null;
					var objectText = null;
					if( objectType == "Text" )
					{
						objectText = objectNodes[j].getElementsByTagName("Text")[0].firstChild.nodeValue;
					}
					else
					{
						objectFile = objectNodes[j].getElementsByTagName("File")[0].firstChild.nodeValue;
					}
					
					var objectLink = null; 
					try{
						objectLink = objectNodes[j].getElementsByTagName("Link")[0].firstChild.nodeValue;
					}catch(ex){}
					
					var objectAlt = null;
					try{
						objectAlt = objectNodes[j].getElementsByTagName("Alt")[0].firstChild.nodeValue;
					}catch(ex){}
					
					var objectTarget = null;
					try{
						objectTarget = objectNodes[j].getElementsByTagName("Target")[0].firstChild.nodeValue;
					}catch(ex){}
					
					var objectDetectStopped = false;
					try{
						var tmpStr = objectNodes[j].getElementsByTagName("DetectStopped")[0].firstChild.nodeValue;	
						tmpStr = tmpStr.toLowerCase();
						objectDetectStopped = ( tmpStr == "true" || tmpstr == 1 ) ? true : false;
					}catch(ex){}
					
					var obj = null;
					switch( objectType )
					{
						case "Image":
							obj = new com.fukuneko.Flvw.FlvImage( objectId, areaId, groupId );
							obj.name = objectName;
							obj.alt = objectAlt;
							obj.interval = objectInterval;
							obj.setFile(objectFile);
							obj.setLink(objectLink, objectTarget);
							obj.loadImage();
							break;
							
						case "Text":
							obj = new com.fukuneko.Flvw.Telop( objectId, areaId, groupId, step );
							obj.name = objectName;
							obj.setText( objectText );
							obj.setLink(objectLink, objectTarget);
							break;
							
						case "Flash":
							obj = new com.fukuneko.Flvw.FlvFlash( objectId, areaId, groupId );
							obj.name = objectName;
							obj.detectStopped = objectDetectStopped;
							obj.interval = objectInterval;
							obj.setFile(objectFile);
							break;
							
						default:
							break;
					}				
					com.fukuneko.Flvw.groupsTemp[i].addObject(obj);
					
				}
			}
		
			com.fukuneko.Flvw.groupsNew = com.fukuneko.Flvw.groupsTemp;
			//alert( "OK" );
			if( com.fukuneko.Flvw.groups == null && com.fukuneko.Flvw.groupsNew != null)
			{
				com.fukuneko.Flvw.groups = com.fukuneko.Flvw.groupsNew;
			}
	
			com.fukuneko.Flvw.RestoreUserSelectedStatus();
			
			com.fukuneko.Flvw.UpdateMenu();
			
			com.fukuneko.Flvw.isProcessing = false;
		}
		else if( Flvw.httpObj.readyState == 4 )
		{
			com.fukuneko.Flvw.isProcessing = false;
		}
	}
	catch(ex)
	{
		com.fukuneko.Flvw.isProcessing = false;
	}

};// ---- ProcessData() ここまで ----

/**
 * ユーザーが選択した値を新しいオブジェクトへ戻す
 */
com.fukuneko.Flvw.RestoreUserSelectedStatus = function()
{
	if( com.fukuneko.Flvw.groups == null ) return;
	if( com.fukuneko.Flvw.groupsNew == null ) return;
	
	// オブジェクトのユーザー選択値を保存
	var objSelected = new Array();
	var curGrps = com.fukuneko.Flvw.groups;
	for( var i = 0; i < curGrps.length; i++ )
	{
		var curObjs = curGrps[i].objects;
		for( var j = 0; j < curObjs.length; j++ )
		{
			var grpId = curGrps[i].Id;
			if( objSelected[grpId] == undefined ) objSelected[grpId] = new Array();
			
			objSelected[grpId][curObjs[j].Id] = curObjs[j].selected;
		}
	}
	// ユーザー選択値の保存ここまで
	
	var grps = com.fukuneko.Flvw.groupsNew;
	for( var i = 0; i < grps.length; i++ )
	{
		if( !grps[i].enabled ) continue;
		
		var groupId = grps[i].Id;
		var objects = grps[i].objects;
		
		for( var j = 0; j < objects.length; j++ )
		{
			var objId = objects[j].Id;
			var sld = true;
			try{ 
				sld = (objSelected[groupId][objId] == false) ? false : true;
			}
			catch(ex){
				 sld = true;
			}
			objects[j].selected = sld;
		}
	}
	
};

/**
 * メニューを更新する
 */
com.fukuneko.Flvw.UpdateMenu = function ()
{
	if( com.fukuneko.Flvw.groupsNew == null ) return;
	
	var grps = com.fukuneko.Flvw.groupsNew;
	for( var i = 0; i < grps.length; i++ )
	{
		if( !grps[i].enabled ) continue;
		
		var groupId = grps[i].Id;
		var menuGroupElementId = com.fukuneko.Flvw.gmap.getMenuGroupElementId(groupId);
		var menuGroupElement = document.getElementById(menuGroupElementId);
		
		if( menuGroupElement == null ) continue;
		
		menuGroupElement.innerHTML = "";
		var innerHtml = "";
		var objects = grps[i].objects;
		
		for( var j = 0; j < objects.length; j++ )
		{
			var objId = objects[j].Id;
			var objSld = (objects[j].selected == true) ? "checked" : "";
			var name = objects[j].name;
			var chkId = groupId + "-" + j;
			innerHtml += '<input type="checkbox" id="'+chkId+'" name="'+chkId+'" value="'+chkId+'" '+objSld+' onClick="com.fukuneko.Flvw.MenuContentObject_Click(this)"/>' + name + '<br />';
		}
		
		menuGroupElement.innerHTML = innerHtml;
	}
};

/**
 * メニューのグループコンテンツオブジェクトのチェックボックスがクリックされたとき
 * @param {Object} obj クリックされたメニューのDOMオブジェクト（自動生成される。通常はinput type="checkbox"
 */
com.fukuneko.Flvw.MenuContentObject_Click = function(obj)
{
	var value = obj.value;
	var spStr = value.split("-");
	var groupId = parseInt(spStr[0], 10);
	var objectId = parseInt(spStr[1], 10);
	var groupIndex = com.fukuneko.Flvw.GetGroupIndexById(com.fukuneko.Flvw.groups, groupId);
	//alert(obj.checked);
	
	var objs = com.fukuneko.Flvw.groups[groupIndex].objects;
	var cnt = 0;
	for(i = 0; i < objs.length; i++ )
	{
		if( objs[i].selected ) cnt++; 
	}
	
	if( !obj.checked && cnt < 2 )
	{
		obj.checked = true;
	}
	com.fukuneko.Flvw.groups[groupIndex].objects[objectId].selected = obj.checked;
};


/**
 * FlvwManagerを起動する（これがFLVWを動作させるエントリーポイント）
 */
com.fukuneko.Flvw.FlvwManagerStart = function()
{
	com.fukuneko.Flvw.gmap.setUserDefInnerElements();
	com.fukuneko.Flvw.timerID = setTimeout("com.fukuneko.Flvw.FlvwManager()", com.fukuneko.Flvw.flvwManagerInterval);
};


/**
 * 定期的に呼び出されるマネージャ（これがFLVWのメイン処理になる）
 */
com.fukuneko.Flvw.FlvwManager = function()
{
	clearTimeout(com.fukuneko.Flvw.timerID);
	
	try
	{
		var curTime = new Date().getTime();
		
		
		if( curTime > (com.fukuneko.Flvw.gotDataLastTime + com.fukuneko.Flvw.gettingDataInterval) )
		{
			com.fukuneko.Flvw.gotDataLastTime = curTime;
			com.fukuneko.Flvw.GetData();
		}
		
		if( com.fukuneko.Flvw.groups != null )
		{
			if( com.fukuneko.Flvw.groups.length >= 1 )
			{
				for( var i = 0; i < com.fukuneko.Flvw.groups.length; i++ )
				{
					if( !com.fukuneko.Flvw.groups[i].enabled ) continue; // グループが有効でない場合は次のグループへ
					
					// グループ内のオブジェクトが独自のインターバル値を持っていればそれを使う
					var curObj = com.fukuneko.Flvw.groups[i].getCurrentObject();
					var interval = com.fukuneko.Flvw.groups[i].interval;
					if( curObj != null )
					{
						if(curObj.interval != null ) interval = curObj.interval;
					}
					
					curTime = new Date().getTime();
					var groupTime = com.fukuneko.Flvw.groups[i].lastTime + interval;
					if( curTime > groupTime )
					{
						switch( com.fukuneko.Flvw.groups[i].groupType )
						{
							case "Fixed" :
								com.fukuneko.Flvw.FixedGroupManager(com.fukuneko.Flvw.groups[i]);
								break;
							
							case "Telop" :
								com.fukuneko.Flvw.TelopGroupManager(com.fukuneko.Flvw.groups[i]);
								break;
								
							default :
								break;
						}// -- End of switch
						com.fukuneko.Flvw.groups[i].updateLastTime(curTime);
					}// -- End of if
				}// -- End of for
			}// End of if
		}// End of if
	}
	catch(ex)
	{}
	
	com.fukuneko.Flvw.timerID = setTimeout("com.fukuneko.Flvw.FlvwManager()", com.fukuneko.Flvw.flvwManagerInterval);
};


/**
 * テロップを動作させる処理
 * @param {Group} groupObj 対象になるグループオブジェクト
 */ 
com.fukuneko.Flvw.TelopGroupManager = function(groupObj)
{
	if( groupObj == null ) return;
	if( groupObj.groupType != "Telop" ) return;
	
	//alert("telop");
	if( groupObj.currentIndex == -1 )
	{
		groupObj.moveToNextObject();
	}
	
	var obj = groupObj.getCurrentObject();
	if( obj == null ) return;
	
	if( obj.isRequireInit )
	{
		obj.setToStartPosition();
	}
	
	// テロップを動かす（trueが帰ってきたらスクロール中）
	if( obj.move() ) return;
	
	// アップデート処理
	if( groupObj.lastUpdate != com.fukuneko.Flvw.groupsNewUpdate )
	{
		var curIndex = groupObj.currentIndex;
		var objLength = groupObj.objects.length;
		//var grpIndex = parseInt(groupObj.Id, 10);
		var grpIndex = com.fukuneko.Flvw.GetGroupIndexById(com.fukuneko.Flvw.groups, groupObj.Id);
		var newGrpIndex = com.fukuneko.Flvw.GetGroupIndexById(com.fukuneko.Flvw.groupsNew, groupObj.Id);
		com.fukuneko.Flvw.groups[grpIndex].dispose();
		delete com.fukuneko.Flvw.groups[grpIndex];
		com.fukuneko.Flvw.groups[grpIndex] = com.fukuneko.Flvw.groupsNew[newGrpIndex];
		if( com.fukuneko.Flvw.groups[grpIndex].objects.length < objLength ) curIndex = 0;
		
		com.fukuneko.Flvw.groups[grpIndex].currentIndex = curIndex;
		com.fukuneko.Flvw.groups[grpIndex].moveToNextObject();
	}
	else
	{
		groupObj.moveToNextObject();
	}
	
};

/**
 * Fixedグループのコンテンツを変更する処理
 * @param {Group} groupObj 対象となるグループオブジェクト
 */
com.fukuneko.Flvw.FixedGroupManager = function(groupObj)
{
	if( groupObj == null ) return;
	if( groupObj.groupType != "Fixed" ) return;
	
	var isIndexMinus = false;
	if( groupObj.currentIndex == -1 )
	{
		groupObj.moveToNextObject();
		isIndexMinus = true;
	}
	
	var obj = groupObj.getCurrentObject();
	
	if( obj.type == "FlvFlash Object" )
	{
		
		if( groupObj.detectStopped && !isIndexMinus ) // Flashの停止検知処理をおこなうかどうか
		{
			if( obj.isPlaying() )
			{
				return;
			}
			else
			{
				groupObj.detectStopped = false;
			}
		}
	}
	
	if( !isIndexMinus )
	{
		groupObj.moveToNextObject();
	}
	
	obj = groupObj.getCurrentObject();
	if( obj == null ) return;
	
	if( obj.type == "FlvImage Object")
	{
		if( obj.image.src == null || obj.image.src == "" )
		{
			obj.loadImage();
		}
		
		obj.showImage();
		com.fukuneko.Flvw.gmap.restoreUserDefInnerElementAttr( groupObj.Id );
	}
	else if( obj.type == "FlvFlash Object" )
	{
		obj.showFlash();
		if( obj.detectStopped )
		{
			groupObj.detectStopped = true;
		}
		else
		{
			groupObj.detectStopped = false;
		}	
	}
	else{ return; }
	
	
	// アップデート処理
	if( groupObj.lastUpdate != com.fukuneko.Flvw.groupsNewUpdate )
	{
		var curIndex = groupObj.currentIndex;
		var objLength = groupObj.objects.length;
		
		//var grpIndex = parseInt(groupObj.Id, 10);
		var grpIndex = com.fukuneko.Flvw.GetGroupIndexById(com.fukuneko.Flvw.groups, groupObj.Id);
		var newGrpIndex = com.fukuneko.Flvw.GetGroupIndexById(com.fukuneko.Flvw.groupsNew, groupObj.Id);
		com.fukuneko.Flvw.groups[grpIndex].dispose();
		delete com.fukuneko.Flvw.groups[grpIndex];
		com.fukuneko.Flvw.groups[grpIndex] = com.fukuneko.Flvw.groupsNew[newGrpIndex];
		if( com.fukuneko.Flvw.groups[grpIndex].objects.length < objLength ) curIndex = 0;
		
		com.fukuneko.Flvw.groups[grpIndex].currentIndex = curIndex;
		//com.fukuneko.Flvw.groups[grpIndex].moveToNextObject();
	}
	else
	{
		//groupObj.moveToNextObject();
	}
	
};


/**
 * HTTP通信用関数
 * @param {String} cbFunc XMLHttpRequestのステータスが変わったときに呼び出されるコールバック関数名
 */
com.fukuneko.Flvw.createXMLHttpRequest = function(cbFunc)
{
	var XMLhttpObject = null;
	try
	{
		XMLhttpObject = new XMLHttpRequest();
	}
	catch(e)
	{
		try
		{
			XMLhttpObject = new ActiveXObject("Msxml2.XMLHTTP");
		}
		catch(e)
		{
			try
			{
				XMLhttpObject = new ActiveXObject("Microsoft.XMLHTTP");
			}
			catch(e)
			{
				return null;
			}
		}
	}
	
	if (XMLhttpObject) XMLhttpObject.onreadystatechange = cbFunc;
	
	return XMLhttpObject;
};
/// Copyright (C) 2007 Fukuneko Corporation. All Rights Reserved.
